{
  Autor      : Michael Springwald
  Erstellt am: 18.09.2011
}

unit uplimagelist;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, contnrs;

type
  { TPLImageListItem }
  TPLImageListItem = class
  private
    fPicture: TPicture;
  protected

  public
    Name:string;
    constructor Create;
    destructor Destroy; override;
    property Picture:TPicture read fPicture write fPicture;
  published

  end; // TPLImageListItem

  TPLImageList = class
  private
    function GetItem(index: Integer): TPLImageListItem;

  protected

  public
    Items:TObjectList;
    constructor Create;
    destructor Destroy; override;

    function AddImageItem(const FileName, aName:String):TPLImageListItem;
    function FindImageItem(const aName:String):TPLImageListItem;

    property Item[index:Integer]:TPLImageListItem read GetItem; Default;
  published

  end; // TPLImageList

implementation

{ TPLImageListItem }
constructor TPLImageListItem.Create;
begin
  inherited Create;
  fPicture:=TPicture.Create;
end; // TPLImageListItem.Create

destructor TPLImageListItem.Destroy;
begin
  FreeAndNil(fPicture);
  inherited Destroy;
end; // TPLImageListItem.Destroy

function TPLImageList.GetItem(index: Integer): TPLImageListItem;
begin
  result:=Items[index] as TPLImageListItem;
end; // TPLImageList.GetItem

constructor TPLImageList.Create;
begin
  inherited Create;
  Items:=TObjectList.Create(True);
end; // TPLImageList.Create

destructor TPLImageList.Destroy;
begin
  FreeAndNil(items);
  inherited Destroy;
end; // TPLImageList.Destroy

function TPLImageList.AddImageItem(const FileName, aName: String): TPLImageListItem;
begin
  result:=Items[Items.Add(TPLImageListItem.Create)] as TPLImageListItem;
  result.Name:=aName;
  result.Picture.LoadFromFile(FileName);
  result.Picture.Bitmap.TransparentColor:=clWhite;
  result.Picture.Bitmap.Transparent:=True;
  result.Picture.Bitmap.TransparentMode:=tmFixed;
end; // TPLImageList.AddImageItem

function TPLImageList.FindImageItem(const aName: String): TPLImageListItem;
var
  i:Integer;
begin
  result:=nil;
  for i:=0 to Items.Count-1 do begin
    if Item[i].Name = aName then begin
      result:=item[i];
      break;
    end;
  end; // for i
end; // TPLImageList.FindImageItem

end.

