{
  Autor      : Michael Springwald
  Erstellt am: 19.09.2011
}

unit uplprinceofpersia;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, ExtCtrls, Forms, contnrs,
  LCLType,LCLProc,LCLIntf, GraphUtil, IntfGraphics, FPimage,
  uplimagelist, uplspriteengine;

type
  TRotateDirection = (rdRight, rdNormal, rdLeft);

  TPlPrinceOfPersia = class;

  TClassItem = class
    C:TObject;
    Name:String;
  end; // TClassItem

  { TPLGameSprite }
  TPLGameSprite = class(TPLSprite)
  private

  protected

  public
    PrinceOfPersia:TPlPrinceOfPersia;
    Data:TPLGameSprite;
    constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); virtual;
    destructor Destroy; override;
    function Create2:TPLGameSprite; virtual; abstract;

    procedure Paint(Visible: Boolean); override;
  published

  end; // TPLGameSprite

    { TPLPillar }
    TPLPillar = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;
    published

    end; // TPLPillar

    { TPLSpikes }
    TPLSpikes = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia);  override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;
    published

    end; // TPLSpikes

    { TPLSkeleton }
    TPLSkeleton = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;
    published

    end; // TPLSkeleton

    { TPlBigPillar }
    TPlBigPillar = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;
    published

    end; // TPlBigPillar

    { TPLDoor }
    TPLDoor = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;

      procedure Paint(Visible: Boolean); override;
    published

    end; // TPLDoor

    { TPLLevelDoorLeft }
    TPLLevelDoorLeft = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;

      procedure Paint(Visible: Boolean); override;
    published

    end; // TPLLevelDoorLeft

    { TPLLevelDoorRight }
    TPLLevelDoorRight = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
      function Create2:TPLGameSprite; override;

      procedure Paint(Visible: Boolean); override;
    published

    end; // TPLLevelDoorRight

    { TPLFloorPanels }
    TPLFloorPanels = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;

      procedure Paint(Visible: Boolean); override;
    published

    end; // TPLFloorPanels

      { TPLNormalPanel }
      TPLNormalPanel = class(TPLFloorPanels)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;

        procedure Paint(Visible: Boolean); override;
      published

      end; // TPLNormalPanel

      { TPLBroken }
      TPLBroken = class(TPLFloorPanels)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        function Create2:TPLGameSprite; override;
        destructor Destroy; override;

      published

      end; // TPLBroken

      { TPLLoose }
      TPLLoose = class(TPLFloorPanels)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        function Create2:TPLGameSprite; override;
        destructor Destroy; override;
      published

      end; // TTPLLoose

    { TPLBackground }
    TPLBackground = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
    published

    end; // TPLBackground

      { TPLBackgroundBricks01 }
      TPLBackgroundBricks01 = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBackgroundBricks01

      { TPLBackgroundBricks02 }
      TPLBackgroundBricks02 = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBackgroundBricks02

      { TPLBackgroundBricks03 }
      TPLBackgroundBricks03 = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published
      end; // TPLBackgroundBricks03

      { TPLBackgroundBricks04 }
      TPLBackgroundBricks04 = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBackgroundBricks04

      { TPLBackgroundWindow }
      TPLBackgroundWindow = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBackgroundWindow

      { TPLBackgroundTorch }
      TPLBackgroundTorch = class(TPLBackground)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBackgroundTorch

    // Gegestände

    { TPLItems }
    TPLItems = class(TPLGameSprite)
    private

    protected

    public
      constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;
    published

    end; // TPLItems

      { TPLBigPotions }
      TPLBigPotions = class(TPLItems)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLBigPotions

      { TPLSmallPotions }
      TPLSmallPotions = class(TPLItems)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLSmallPotions

      { TPLSword }
      TPLSword = class(TPLItems)
      private

      protected

      public
        constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
        destructor Destroy; override;
        function Create2:TPLGameSprite; override;
      published

      end; // TPLSword

    { TPLKid }
    TPLKid = class(TPLGameSprite)
    private
      fDir: Boolean;
      procedure SetDir(const AValue: Boolean);
    protected

    public
      Timer, Timer2:TTimer;
      AniFrameIndex:Integer;
      T1, T2, T3, T4:DWord;
      Z:Integer;
      constructor Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia); override;
      destructor Destroy; override;

      procedure Paint(Visible: Boolean); override;
      procedure onTimer(Sender:TObject);
      procedure onTimer2(Sender:TObject);
      property dir:Boolean read fDir write SetDir;
    published

    end; // TPLKid

  { TPlPrinceOfPersia }
  TPlPrinceOfPersia = class(TPLSpriteEngineRaster)
  private

  protected

  public
    ExeDir, ObjDir:String;
    LevelElements:array[0..79] of TPLImageListItem;
    keys:array[0..256] of Boolean;
    ClassList:TObjectList;
    constructor Create(const aWidth, aHeight, aTileWidth, aTileHeight:Integer); override;
    destructor Destroy; override;

    procedure AddClassList(const Name:String; c:TObject);
    procedure FillClassList;
    procedure FillImageList;

    function AddGameSprite(const aLeft,aTop:Integer; aSprite:TPLGameSprite):TPLGameSprite;
    procedure InitKeys;
    procedure OnLevelLoadChar(c: char; x, y: Integer); override;

    procedure Paint; override;
  published

  end; // TPlPrinceOfPersia

    operator := (const b : TBitmap) : TLazIntfImage;
    operator := (const i : TLazIntfImage) : TBitmap;

implementation

operator := (const b : TBitmap) : TLazIntfImage;
begin
  Result := TLazIntfImage.Create(0,0);
  Result.LoadFromBitmap(b.Handle,b.MaskHandle);
end;

operator := (const i : TLazIntfImage) : TBitmap;
var
   ImageHandle, MaskHandle : HBitmap;
begin
  Result := TBitmap.Create;
  i.CreateBitmaps(ImageHandle, MaskHandle);
  Result.Handle:=ImageHandle;
  Result.MaskHandle:=MaskHandle;
end;

procedure DoRotate(var FRotatedImage:TLazIntfImage; FNormalImage:TLazIntfImage; FRotateTo:TRotateDirection) ;
var
   px, py, iw, ih, nx, ny : Integer;
   CurColor: TFPColor;
begin

   FRotatedImage := TLazIntfImage.Create(0,0);
   FRotatedImage.DataDescription := GetDescriptionFromDevice(0);
   FRotatedImage.SetSize(FNormalImage.Width,FNormalImage.Height);
   FRotatedImage.FillPixels(colBlack);
//   if FRotateTo=rdNormal then Exit;


  for py := FNormalImage.Height-1 downto 0 do
    for px := FNormalImage.Width-1 downto 0 do
    begin
       if FRotateTo = rdRight then
         FRotatedImage.Colors[FRotatedImage.Width-1-px,py]:= FNormalImage.Colors[px,py]
       else
         FRotatedImage.Colors[px,py]:= FNormalImage.Colors[px,py]

     end;
end;

procedure flip_horizontal(Quelle: TBitMap; var Ziel: TBitMap);
begin

  Ziel.Assign(Quelle);
  Ziel.Width  := Quelle.Width;
  Ziel.Height := Quelle.Height;
//  Ziel.Canvas.FillRect(0,0,Quelle.Width,Ziel.Height);
//  Ziel.Canvas.Stretchdraw(Rect(0,Quelle.Height,Ziel.Width, ziel.Height),Quelle);

  StretchBlt(Ziel.Canvas.Handle, 0, 0, Ziel.Width, Ziel.Height, Quelle.Canvas.Handle,
    0, 0, Quelle.Width, Quelle.Height, srccopy);
end;

procedure flip_vertikal(Quelle, Ziel: TBitMap);
begin
  Ziel.Assign(nil);
  Ziel.Width  := Quelle.Width;
  Ziel.Height := Quelle.Height;
  StretchBlt(Ziel.Canvas.Handle, 0, 0, Ziel.Width, Ziel.Height, Quelle.Canvas.Handle,
    Quelle.Width, 0, Quelle.Width, Quelle.Height, srccopy);
end;

{ TPlPrinceOfPersia }
constructor TPlPrinceOfPersia.Create(const aWidth, aHeight, aTileWidth, aTileHeight:Integer);
begin
  inherited Create(aWidth, aHeight, aTileWidth, aTileHeight);
  DataDir:=ExtractFileDir(ParamStr(0)) + DirectorySeparator+'data'+DirectorySeparator;
  // vdungeon / vpalace
  ObjDir:=DataDir+'vdungeon'+DirectorySeparator;
  ClassList:=TObjectList.Create;
  FillImageList;
  SetGameSize;
  Background.Canvas.Brush.Color:=clBlack;
  Background.Canvas.FillRect(0,0,Background.Width, Background.Height);

  FillClassList;
  ViewRaster:=True;
//  LevelLoaderRaster.LoadFromFile(DataDir+'levels/testlevels/level01.lvl');
end; // TPlPrinceOfPersia.Create

destructor TPlPrinceOfPersia.Destroy;
begin
  FreeAndNil(ClassList);
  inherited Destroy;
end; // TPlPrinceOfPersia.Destroy

procedure TPlPrinceOfPersia.AddClassList(const Name: String; c: TObject);
var
  cl:TClassItem;
begin
  cl:=TClassItem.Create;
  cl.Name:=Name;
  cl.C:=c;
  ClassList.Add(cl);
end; // TPlPrinceOfPersia.AddClassList

procedure TPlPrinceOfPersia.FillClassList;
begin
{01} AddClassList('Pillar',TPLPillar.Create(nil,self));
{02} AddClassList('Spikes',TPLSpikes.Create(nil,self));
{03} AddClassList('Skeleton',TPLSkeleton.Create(nil,self));
{04} AddClassList('BigPillar',TPlBigPillar.Create(nil,self));
{05} AddClassList('Door',TPLDoor.Create(nil,self));
{06} AddClassList('Level Door Left',TPLLevelDoorLeft.Create(nil,self));
{07} AddClassList('Level Door Right',TPLLevelDoorRight.Create(nil,self));

{08} AddClassList('Normal Panel',TPLNormalPanel.Create(nil,self));
{09} AddClassList('Broken Panel',TPLBroken.Create(nil,self));
{11} AddClassList('Loose Panel',TPLLoose.Create(nil,self));

{11} AddClassList('Bricks1',TPLBackgroundBricks01.Create(nil,self));
{12} AddClassList('Bricks2',TPLBackgroundBricks02.Create(nil,self));
{13} AddClassList('Bricks3',TPLBackgroundBricks03.Create(nil,self));
{14} AddClassList('Bricks4',TPLBackgroundBricks04.Create(nil,self));
{15} AddClassList('Window',TPLBackgroundWindow.Create(nil,self));
{16} AddClassList('Torch',TPLBackgroundTorch.Create(nil,self));

{17} AddClassList('Big Potions',TPLBigPotions.Create(nil,self));
{18} AddClassList('Smal Potions',TPLSmallPotions.Create(nil,self));

{19} AddClassList('Sword',TPLSword.Create(nil,self));

end; // TPlPrinceOfPersia.FillClassList

procedure TPlPrinceOfPersia.FillImageList;
var
  str:string;
begin
  str:='';
// floor panels
  LevelElements[0]:=ImageList.AddImageItem(ObjDir+'floor panels/normal left.bmp','');
  LevelElements[1]:=ImageList.AddImageItem(ObjDir+'floor panels/normal right.bmp','');
  LevelElements[2]:=ImageList.AddImageItem(ObjDir+'floor panels/normal base.bmp','');
// spikes
  LevelElements[3]:=ImageList.AddImageItem(ObjDir+'floor panels/spikes left.bmp','');
  LevelElements[4]:=ImageList.AddImageItem(ObjDir+'floor panels/spikes right.bmp','');
// skeleton
  LevelElements[5]:=ImageList.AddImageItem(DataDir+'vdungeon/floor panels/skeleton left.bmp','');
  LevelElements[6]:=ImageList.AddImageItem(DataDir+'vdungeon/floor panels/skeleton right.bmp','');
// big pillar
  LevelElements[7]:=ImageList.AddImageItem(ObjDir+'big pillar/big pillar left lower.bmp','');
  LevelElements[8]:=ImageList.AddImageItem(ObjDir+'big pillar/big pillar right lower.bmp','');

  LevelElements[9]:=ImageList.AddImageItem(ObjDir+'big pillar/big pillar left upper.bmp','');
  LevelElements[10]:=ImageList.AddImageItem(ObjDir+'big pillar/big pillar right upper.bmp','');

// Door
  LevelElements[10]:=ImageList.AddImageItem(ObjDir+'door/door frame left pole.bmp','');
  LevelElements[11]:=ImageList.AddImageItem(ObjDir+'door/door frame left.bmp','');
  LevelElements[12]:=ImageList.AddImageItem(ObjDir+'door/door frame right top.bmp','');
  LevelElements[13]:=ImageList.AddImageItem(ObjDir+'door/door frame right.bmp','');
  LevelElements[15]:=ImageList.AddImageItem(ObjDir+'door/res00250.bmp','');
  LevelElements[16]:=ImageList.AddImageItem(ObjDir+'door/res00251.bmp','');
  LevelElements[17]:=ImageList.AddImageItem(ObjDir+'door/res00252.bmp','');
  LevelElements[18]:=ImageList.AddImageItem(ObjDir+'door/res00253.bmp','');
  LevelElements[19]:=ImageList.AddImageItem(ObjDir+'door/res00254.bmp','');
  LevelElements[20]:=ImageList.AddImageItem(ObjDir+'door/res00255.bmp','');
  LevelElements[21]:=ImageList.AddImageItem(ObjDir+'door/res00256.bmp','');
  LevelElements[22]:=ImageList.AddImageItem(ObjDir+'door/res00257.bmp','');
  LevelElements[23]:=ImageList.AddImageItem(ObjDir+'door/res00258.bmp','');
  LevelElements[24]:=ImageList.AddImageItem(ObjDir+'door/res00259.bmp','');
  LevelElements[25]:=ImageList.AddImageItem(ObjDir+'door/res00260.bmp','');
  LevelElements[26]:=ImageList.AddImageItem(ObjDir+'door/res00261.bmp','');
  LevelElements[27]:=ImageList.AddImageItem(ObjDir+'door/res00262.bmp','');
  LevelElements[28]:=ImageList.AddImageItem(ObjDir+'door/res00263.bmp','');
  LevelElements[29]:=ImageList.AddImageItem(ObjDir+'door/res00264.bmp','');
  LevelElements[30]:=ImageList.AddImageItem(ObjDir+'door/res00265.bmp','');
  LevelElements[31]:=ImageList.AddImageItem(ObjDir+'door/res00266.bmp','');
  LevelElements[32]:=ImageList.AddImageItem(ObjDir+'door/res00267.bmp','');
  LevelElements[33]:=ImageList.AddImageItem(ObjDir+'door/res00285.bmp','');

// Kid
  LevelElements[34]:=ImageList.AddImageItem(DataDir+'kid/normal.bmp','');
  LevelElements[35]:=ImageList.AddImageItem(DataDir+'kid/running/frame01.bmp','');
  LevelElements[36]:=ImageList.AddImageItem(DataDir+'kid/running/frame02.bmp','');
  LevelElements[37]:=ImageList.AddImageItem(DataDir+'kid/running/frame03.bmp','');
  LevelElements[38]:=ImageList.AddImageItem(DataDir+'kid/running/frame04.bmp','');
  LevelElements[39]:=ImageList.AddImageItem(DataDir+'kid/running/frame05.bmp','');
  LevelElements[40]:=ImageList.AddImageItem(DataDir+'kid/running/frame06.bmp','');
  LevelElements[41]:=ImageList.AddImageItem(DataDir+'kid/running/frame07.bmp','');
  LevelElements[42]:=ImageList.AddImageItem(DataDir+'kid/running/frame08.bmp','');
  LevelElements[43]:=ImageList.AddImageItem(DataDir+'kid/running/frame09.bmp','');
  LevelElements[44]:=ImageList.AddImageItem(DataDir+'kid/running/frame10.bmp','');
  LevelElements[45]:=ImageList.AddImageItem(DataDir+'kid/running/frame11.bmp','');
  LevelElements[46]:=ImageList.AddImageItem(DataDir+'kid/running/frame12.bmp','');
  LevelElements[47]:=ImageList.AddImageItem(DataDir+'kid/running/frame13.bmp','');
  LevelElements[48]:=ImageList.AddImageItem(DataDir+'kid/running/frame14.bmp','');

// Pillar
  LevelElements[49]:=ImageList.AddImageItem(ObjDir+'pillar/pillar left.bmp','');
  LevelElements[50]:=ImageList.AddImageItem(ObjDir+'pillar/pillar right main.bmp','');
  LevelElements[51]:=ImageList.AddImageItem(ObjDir+'pillar/pillar right top.bmp','');
  LevelElements[52]:=ImageList.AddImageItem(ObjDir+'pillar/pillar.bmp','');

// Level Door
  LevelElements[53]:=ImageList.AddImageItem(ObjDir+'level door/door bottom.bmp','');
  LevelElements[54]:=ImageList.AddImageItem(ObjDir+'level door/door top.bmp','');
  LevelElements[55]:=ImageList.AddImageItem(ObjDir+'level door/floor.bmp','');
  LevelElements[56]:=ImageList.AddImageItem(ObjDir+'level door/frame lower left.bmp','');
  LevelElements[57]:=ImageList.AddImageItem(ObjDir+'level door/frame lower right.bmp','');
  LevelElements[58]:=ImageList.AddImageItem(ObjDir+'level door/frame upper left.bmp','');
  LevelElements[59]:=ImageList.AddImageItem(ObjDir+'level door/frame upper right.bmp','');
  LevelElements[60]:=ImageList.AddImageItem(ObjDir+'level door/stairs.bmp','');

  // Broken
  LevelElements[61]:=ImageList.AddImageItem(ObjDir+'floor panels/broken left.bmp','');
  LevelElements[62]:=ImageList.AddImageItem(ObjDir+'floor panels/broken right.bmp','');
  LevelElements[63]:=ImageList.AddImageItem(ObjDir+'floor panels/broken left02.bmp','');

  // loose Pannels
  LevelElements[64]:=ImageList.AddImageItem(ObjDir+'floor panels/loose left01.bmp','');
  LevelElements[65]:=ImageList.AddImageItem(ObjDir+'floor panels/loose right01.bmp','');
  LevelElements[66]:=ImageList.AddImageItem(ObjDir+'floor panels/loose left02.bmp','');
  LevelElements[67]:=ImageList.AddImageItem(ObjDir+'floor panels/loose right02.bmp','');
  LevelElements[68]:=ImageList.AddImageItem(ObjDir+'floor panels/loose base01.bmp','');
  LevelElements[69]:=ImageList.AddImageItem(ObjDir+'floor panels/loose base02.bmp','');

  // Backgrund
  LevelElements[70]:=ImageList.AddImageItem(ObjDir+'background/bricks01.bmp','');
  LevelElements[71]:=ImageList.AddImageItem(ObjDir+'background/bricks02.bmp','');
  LevelElements[72]:=ImageList.AddImageItem(ObjDir+'background/bricks03.bmp','');
  LevelElements[73]:=ImageList.AddImageItem(ObjDir+'background/bricks04.bmp','');
  LevelElements[74]:=ImageList.AddImageItem(ObjDir+'background/torch.bmp','');
  LevelElements[75]:=ImageList.AddImageItem(ObjDir+'background/window.bmp','');

  // Getränke
  LevelElements[76]:=ImageList.AddImageItem(DataDir+'prince/potions/base/big dungeon.bmp','');
  LevelElements[77]:=ImageList.AddImageItem(DataDir+'prince/potions/base/small dungeon.bmp','');

  // Das schwert
  LevelElements[78]:=ImageList.AddImageItem(DataDir+'prince/sword/in the floor/normal.bmp','');
  LevelElements[79]:=ImageList.AddImageItem(DataDir+'prince/sword/in the floor/bright.bmp','');

end; // TPlPrinceOfPersia.FillImageList

function TPlPrinceOfPersia.AddGameSprite(const aLeft, aTop: Integer; aSprite:TPLGameSprite): TPLGameSprite;
begin
  Map[aTop, aLeft]:=aSprite;
  writeln(aLeft * TileWidth,'||',(TileWidth div 2));
  Map[aTop, aLeft].Left:=((aLeft * TileWidth)+(TileWidth div 2));

//  if (Map[aTop, aLeft] is TPLNormalPanel) then
    Map[aTop, aLeft].Top:=aTop * TileHeight;
//  else
  //  Map[aTop, aLeft].Top:=(aTop * TileHeight) - (Map[aTop, aLeft].BitMap.Height-16);

  result:=Map[aTop, aLeft] as TPLGameSprite;
end; // TPlPrinceOfPersia.AddGameSprite

procedure TPlPrinceOfPersia.InitKeys;
var
  i:integer;
begin
  for i:=0 to 256 do keys[i]:=False;
end; // TPlPrinceOfPersia.InitKeys

procedure TPlPrinceOfPersia.OnLevelLoadChar(c: char; x, y: Integer);
begin
  case c of
    '1': Map[y,x]:=TPLNormalPanel.Create(nil,self);
    '2': Map[y,x]:=TPLBroken.Create(nil,self);
    '3': Map[y,x]:=TPLSkeleton.Create(nil,self);
    '4': Map[y,x]:=TPLSpikes.Create(nil,self);
    '5': Map[y,x]:=TPlBigPillar.Create(nil,self);
    '6': Map[y,x]:=TPLDoor.Create(nil,self);
    '7': Map[y,x]:=TPLLevelDoorLeft.Create(nil,self);
  end; // c

end; // TPlPrinceOfPersia.OnLevelLoadChar

procedure TPlPrinceOfPersia.Paint;
var
  x,y,l,px,py, p1:Integer;
begin
  Canvas.Draw(Left,Top, Background);
  BackupBuffer.Canvas.Draw(0,0, Background);
  px:=0; py:=0;
  for y:=0 to TileVertiCount do begin
    for x:=0 to TileHoriCount do begin
      if Assigned(Map[y,x]) then begin
        Map[y,x].isBackupBuffer:=False;
        Map[y,x].paint(True);
      end;
      if ViewRaster then begin
        Canvas.Brush.Style:=bsClear;
        Canvas.Pen.Color:=clYellow;
        Canvas.Rectangle(x * TileWidth,y * TileHeight,(x * TileWidth)+TileWidth,(y * TileHeight)+TileHeight);

        Background.Canvas.Brush.Style:=bsClear;
        Background.Canvas.Pen.Color:=clYellow;
        Background.Canvas.Rectangle(px,py,px,py+TileHeight);
        px:=px+(TileWidth div 2);
      end;
    end; // for x
    px:=0;
    py:=py+TileHeight;
  end; // for y

end;

{ TPLGameSprite }
constructor TPLGameSprite.Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia);
begin
  inherited Create(nil, aPrinceOfPersia);
  BitMap.TransparentColor:=clBlack;
  BitMap.TransparentMode:=tmFixed;
  BitMap.Transparent:=True;
  BitMap.Canvas.Brush.Color:=clBlack;
  PrinceOfPersia:=aPrinceOfPersia;
  Data:=nil;
end; // TPLGameSprite.Create

destructor TPLGameSprite.Destroy;
begin
  PrinceOfPersia:=nil;
  inherited Destroy;
end; // TPLGameSprite.Destroy

procedure TPLGameSprite.Paint(Visible: Boolean);
begin
//  BitMap.Width:=32;
//  BitMap.Height:=32;
//  BitMap.Canvas.GradientFill(Rect(0,0,32,32),clRed, clBlue, gdHorizontal);
  inherited Paint(Visible);
  if Assigned(Data) then Data.Paint(True);
end; // TPLGameSprite.Paint

{ TPLFloorPanels }
constructor TPLFloorPanels.Create(aImageItem: TPLImageListItem;  aPrinceOfPersia:TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
end; // TPLFloorPanels.Create

destructor TPLFloorPanels.Destroy;
begin
  inherited Destroy;
end; // TPLFloorPanels.Destroy

procedure TPLFloorPanels.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLFloorPanels.Paint

{ TPLNormalPanel }
constructor TPLNormalPanel.Create(aImageItem: TPLImageListItem;aPrinceOfPersia:TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;

    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    BitMap.Canvas.Draw(0,TileHeight-LevelElements[0].Picture.Height-LevelElements[2].Picture.Bitmap.Height,LevelElements[0].Picture.Bitmap);

    BitMap.Canvas.Draw(LevelElements[0].Picture.Width,TileHeight-LevelElements[0].Picture.Height-LevelElements[2].Picture.Bitmap.Height,LevelElements[1].Picture.Bitmap);

    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap);
  end;
end; // TPLNormalPanel.Create

destructor TPLNormalPanel.Destroy;
begin
  inherited Destroy;
end; // TPLNormalPanel.Destroy

function TPLNormalPanel.Create2: TPLGameSprite;
begin
  Result:=TPLNormalPanel.Create(nil,PrinceOfPersia);
end; // TPLNormalPanel.Create2

procedure TPLNormalPanel.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLNormalPanel.Paint

procedure TPLKid.SetDir(const AValue: Boolean);
var
  RotatedImage:TLazIntfImage;
  px,py:Integer;
begin
  if fDir=AValue then exit;
  fDir:=AValue;
  with PrinceOfPersia do begin
    BitMap.Width:=LevelElements[34].Picture.Width;
    BitMap.Height:=LevelElements[34].Picture.Height;

    BitMap.Canvas.Brush.Color:=clLime;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    if fDir then
      DoRotate(RotatedImage,LevelElements[34].Picture.Bitmap,rdNormal)
    else
      DoRotate(RotatedImage,LevelElements[34].Picture.Bitmap,rdRight);

    BitMap.LoadFromIntfImage(RotatedImage);
    FreeAndNil(RotatedImage);
  end;
end; // TPLKid.SetDir

{ TPLKid }
constructor TPLKid.Create(aImageItem: TPLImageListItem; aPrinceOfPersia:TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  Z:=0;
  T1:=0; T2:=0; T3:=0; T4:=0;
  Dir:=True; // Links
  Timer:=TTimer.Create(nil);
//  Timer.OnStartTimer:=@onTimer;
  Timer.OnTimer:=@onTimer;
  Timer.Interval:=1;
  Timer.Enabled:=False;

  Timer2:=TTimer.Create(nil);
//  Timer2.OnStartTimer:=@onTimer2;
  Timer2.OnTimer:=@onTimer2;
  Timer2.Interval:=1;
  Timer2.Enabled:=False;

  AniFrameIndex:=0;
end; // TPLKid.Create

destructor TPLKid.Destroy;
begin
  FreeAndNil(Timer); FreeAndNil(Timer2);
  inherited Destroy;
end; // TPLKid.Destroy

procedure TPLKid.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLKid.Paint

procedure TPLKid.onTimer(Sender: TObject);
begin
  sleep(2);
  Timer2.Enabled:=False;
  if (t1 = 0) or (t2-t1 >=75) then begin
    t1:=GetTickCount;
    Restor;
    if PrinceOfPersia.keys[VK_RIGHT] then dir:=True;
    if PrinceOfPersia.keys[VK_LEFT] then dir:=False;
    Paint(True);
    if not Timer2.Enabled then begin
      Timer2.Enabled:=True;
      Timer.Enabled:=False;
      onTimer2(Sender);
    end;
  end;
  t2:=GetTickCount;
end; // TPLKid.onTimer

procedure TPLKid.onTimer2(Sender: TObject);
var
  RotatedImage:TLazIntfImage;
begin
//  AniFrameIndex:=0;
//  while AniFrameIndex <=14 do begin
  sleep(1);
    if (t3 = 0) or (t4-t3 >=60) then begin
      T3:=GetTickCount;
      Restor;
      inc(AniFrameIndex);
      if AniFrameIndex >=13 then begin
        AniFrameIndex:=0; t3:=0; t1:=0; t4:=0; t2:=0;
        Timer2.Enabled:=False;
      end;
      BitMap.Width:=PrinceOfPersia.LevelElements[34+AniFrameIndex].Picture.Bitmap.Width;
      if dir then Left:=Left+8 else Left:=Left-8;

      BitMap.Height:=PrinceOfPersia.LevelElements[34+AniFrameIndex].Picture.Bitmap.Height;
      if not dir then
        BitMap.Canvas.Draw(0,0,PrinceOfPersia.LevelElements[34+AniFrameIndex].Picture.Bitmap)
      else begin
        DoRotate(RotatedImage,PrinceOfPersia.LevelElements[34+AniFrameIndex].Picture.Bitmap,rdRight);
        BitMap.LoadFromIntfImage(RotatedImage);
      end;

      Paint(True);
    end;
    T4:=GetTickCount;
//  Timer2.Enabled:=False;
end;

{ TPLDoor }
constructor TPLDoor.Create(aImageItem: TPLImageListItem;  aPrinceOfPersia: TPlPrinceOfPersia);
var
  h1:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);

  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    BitMap.Canvas.Draw(0,13,LevelElements[11].Picture.Bitmap); // Linke Seite(door frame left pole)
    BitMap.Canvas.Draw(32,13,LevelElements[13].Picture.Bitmap); // Die Recht Seite (door frame right)
    BitMap.Canvas.Draw(32,0,LevelElements[12].Picture.Bitmap); // Die Obere Recht Ecke(door frame right)

    BitMap.Canvas.Draw(0,73,LevelElements[2].Picture.Bitmap); // Davor(normal base)

//    BitMap.Canvas.Draw(LevelElements[2].Picture.Width,0,LevelElements[12].Picture.Bitmap);

    h1:=LevelElements[17].Picture.Bitmap.Height;

    BitMap.Canvas.Draw(32,BitMap.Height-(h1*8),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*7),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*6),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*5),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*4),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*3),LevelElements[17].Picture.Bitmap);
    BitMap.Canvas.Draw(32,BitMap.Height-(h1*2),LevelElements[16].Picture.Bitmap);
  end;

end; // TPLDoor.Create

destructor TPLDoor.Destroy;
begin
  inherited Destroy;
end;

function TPLDoor.Create2: TPLGameSprite;
begin
  Result:=TPLDoor.Create(nil,PrinceOfPersia);
end; // TPLDoor.Create2

procedure TPLDoor.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLDoor.Paint

{ TPlBigPillar }
constructor TPlBigPillar.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffSetY:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    OffSetY:=TileHeight-LevelElements[7].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffSetY,LevelElements[7].Picture.Bitmap); // big pillar left lower
    BitMap.Canvas.Draw(32,OffSetY,LevelElements[8].Picture.Bitmap); // big pillar right lower
    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap); // Davor(normal base)
  end; // with
end; // TPlBigPillar.Create

destructor TPlBigPillar.Destroy;
begin
  inherited Destroy;
end; // TPlBigPillar.Destroy

function TPlBigPillar.Create2: TPLGameSprite;
begin
  Result:=TPlBigPillar.Create(nil,PrinceOfPersia);
end; // TPlBigPillar.Create2

{ TPLSkeleton }
constructor TPLSkeleton.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffSetY:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;

    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    OffSetY:=TileHeight-LevelElements[5].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffSetY,LevelElements[5].Picture.Bitmap); // skeleton left lower
    BitMap.Canvas.Draw(LevelElements[5].Picture.Bitmap.Width,OffSetY,LevelElements[6].Picture.Bitmap); // skeleton right lower
    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap); // Davor(normal base)
  end; // with
end; // TPLSkeleton.Create

destructor TPLSkeleton.Destroy;
begin
  inherited Destroy;
end; // TPLSkeleton.Destroy

function TPLSkeleton.Create2: TPLGameSprite;
begin
  Result:=TPlSkeleton.Create(nil,PrinceOfPersia);
end; // TPLSkeleton.Create2

{ TPLSpikes }
constructor TPLSpikes.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffsetY:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    OffsetY:=TileHeight-LevelElements[3].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffsetY,LevelElements[3].Picture.Bitmap); // skeleton left lower
    BitMap.Canvas.Draw(LevelElements[3].Picture.Bitmap.Width,OffsetY,LevelElements[4].Picture.Bitmap); // skeleton right lower
    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap); // Davor(normal base)
  end;
end; // TPLSpikes.Create

destructor TPLSpikes.Destroy;
begin
  inherited Destroy;
end;

function TPLSpikes.Create2: TPLGameSprite;
begin
  Result:=TPLSpikes.Create(nil,PrinceOfPersia);
end; // TPLSpikes.Create2

{ TPLPillar }
constructor TPLPillar.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffSetY:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;

    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    OffSetY:=TileHeight-LevelElements[49].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffSetY,LevelElements[49].Picture.Bitmap); // Linke Seite
    BitMap.Canvas.Draw(32,OffSetY,LevelElements[50].Picture.Bitmap); // Die Recht Seite
//    BitMap.Canvas.Draw(32,LevelElements[50].Picture.Bitmap.,LevelElements[51].Picture.Bitmap); // Die Obere Recht Ecke

    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap); // Davor(normal base)

  end;
end; // TPLPillar.Create

destructor TPLPillar.Destroy;
begin
  inherited Destroy;
end; // TPLPillar.Destroy

function TPLPillar.Create2: TPLGameSprite;
begin
  Result:=TPLPillar.Create(nil,PrinceOfPersia);
end; // TPLPillar.Create2

{ TPLLevelDoorLeft }
constructor TPLLevelDoorLeft.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);

  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,6,LevelElements[56].Picture.Bitmap); // frame lower left.bmp
//    BitMap.Canvas.Draw(32,6,LevelElements[57].Picture.Bitmap); // frame lower right.bmp

    BitMap.Canvas.Draw(0,0,LevelElements[58].Picture.Bitmap); // frame upper left.bmp
  //  BitMap.Canvas.Draw(32,0,LevelElements[59].Picture.Bitmap); // frame upper right.bmp

{    BitMap.Canvas.Draw(8,12,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,16,LevelElements[53].Picture.Bitmap);  // door bottom.bmp
    BitMap.Canvas.Draw(8,20,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,24,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,28,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,32,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,36,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,40,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,44,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,48,LevelElements[53].Picture.Bitmap);}

//    BitMap.Canvas.Draw(8,50,LevelElements[53].Picture.Bitmap);

    BitMap.Canvas.Draw(0,66,LevelElements[2].Picture.Bitmap);
  end; // with
end; // TPLLevelDoorLeft.Create

destructor TPLLevelDoorLeft.Destroy;
begin
  inherited Destroy;
end; // TPLLevelDoorLeft.Destroy

function TPLLevelDoorLeft.Create2: TPLGameSprite;
begin
  Result:=TPLLevelDoorLeft.Create(nil,PrinceOfPersia);
end; // TPLLevelDoorLeft.Create2

procedure TPLLevelDoorLeft.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLLevelDoorLeft.Paint

{ TPLBroken }
constructor TPLBroken.Create(aImageItem: TPLImageListItem;  aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffSetY:Integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);

  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;

    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    OffSetY:=TileHeight-LevelElements[61].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffSetY,LevelElements[61].Picture.Bitmap);

    BitMap.Canvas.Draw(LevelElements[0].Picture.Width,OffSetY,LevelElements[62].Picture.Bitmap);

    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Bitmap.Height,LevelElements[2].Picture.Bitmap);
  end;

end; // TPLBroken.Create

function TPLBroken.Create2: TPLGameSprite;
begin
  Result:=TPLBroken.Create(nil,PrinceOfPersia);
end; // TPLBroken.Create2

destructor TPLBroken.Destroy;
begin
  inherited Destroy;
end; // TPLBroken.Destroy

{ TPLLoose }
constructor TPLLoose.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
var
  OffSetY:integer;
begin
  inherited Create(aImageItem, aPrinceOfPersia);

  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;

    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);

    OffSetY:=TileHeight-LevelElements[64].Picture.Bitmap.Height-LevelElements[2].Picture.Bitmap.Height;
    BitMap.Canvas.Draw(0,OffSetY,LevelElements[64].Picture.Bitmap);

    BitMap.Canvas.Draw(LevelElements[0].Picture.Width,OffSetY,LevelElements[65].Picture.Bitmap);

    BitMap.Canvas.Draw(0,TileHeight-LevelElements[2].Picture.Height,LevelElements[2].Picture.Bitmap);
  end;

end; // TPLLoose.Create

function TPLLoose.Create2: TPLGameSprite;
begin
  Result:=TPLLoose.Create(nil,PrinceOfPersia);
end; // TPLLoose.Create2

destructor TPLLoose.Destroy;
begin
  inherited Destroy;
end; // TPLLoose.Destroy

{ TPLBackground }
constructor TPLBackground.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
end; // TPLBackground.Create

destructor TPLBackground.Destroy;
begin
  inherited Destroy;
end; // TPLBackground.Destroy

{ TPLBackgroundBricks01 }
constructor TPLBackgroundBricks01.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[70].Picture.Bitmap);
  end; // with
end; // TPLBackgroundBricks01.Create

destructor TPLBackgroundBricks01.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundBricks01.Destroy

function TPLBackgroundBricks01.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundBricks01.Create(nil,PrinceOfPersia);
end; // TPLBackgroundBricks01.Create2

{ TPLBackgroundBricks02 }
constructor TPLBackgroundBricks02.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[71].Picture.Bitmap);
  end; // with
end; // TPLBackgroundBricks02.Create

destructor TPLBackgroundBricks02.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundBricks02.Destroy

function TPLBackgroundBricks02.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundBricks02.Create(nil,PrinceOfPersia);
end; // TPLBackgroundBricks02.Create2

{ TPLBackgroundBricks03 }
constructor TPLBackgroundBricks03.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[72].Picture.Bitmap);
  end; // with

end; // TPLBackgroundBricks03.Create

destructor TPLBackgroundBricks03.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundBricks03.Destroy

function TPLBackgroundBricks03.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundBricks03.Create(nil,PrinceOfPersia);
end; // TPLBackgroundBricks03.Create2

{ TPLBackgroundBricks04 }
constructor TPLBackgroundBricks04.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[73].Picture.Bitmap);
  end; // with
end; // TPLBackgroundBricks04.Create

destructor TPLBackgroundBricks04.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundBricks04.Destroy

function TPLBackgroundBricks04.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundBricks04.Create(nil,PrinceOfPersia);
end; // TPLBackgroundBricks04.Create2

{ TPLBackgroundWindow }
constructor TPLBackgroundWindow.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[75].Picture.Bitmap);
  end; // with
end; // TPLBackgroundWindow.Create

destructor TPLBackgroundWindow.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundWindow.Destroy

function TPLBackgroundWindow.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundWindow.Create(nil,PrinceOfPersia);
end; // TPLBackgroundWindow.Create2

{ TPLBackgroundTorch }
constructor TPLBackgroundTorch.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[74].Picture.Bitmap);
  end; // with
end; // TPLBackgroundTorch.Create

destructor TPLBackgroundTorch.Destroy;
begin
  inherited Destroy;
end; // TPLBackgroundTorch.Destroy

function TPLBackgroundTorch.Create2: TPLGameSprite;
begin
  Result:=TPLBackgroundTorch.Create(nil,PrinceOfPersia);
end; // TPLBackgroundTorch.Create2

{ TPLItems }
constructor TPLItems.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
end; // TPLItems.Create

destructor TPLItems.Destroy;
begin
  inherited Destroy;
end; // TPLItems.Destroy

{ TPLBigPotions }
constructor TPLBigPotions.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[76].Picture.Bitmap);
  end; // with
end; // TPLBigPotions.Create

destructor TPLBigPotions.Destroy;
begin
  inherited Destroy;
end; // TPLBigPotions.Destroy

function TPLBigPotions.Create2: TPLGameSprite;
begin
  Result:=TPLBigPotions.Create(nil,PrinceOfPersia);
end; // TPLBigPotions.Create2

{ TPLSmallPotions }
constructor TPLSmallPotions.Create(aImageItem: TPLImageListItem; aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[77].Picture.Bitmap);
  end; // with
end; // TPLSmallPotions.Create

destructor TPLSmallPotions.Destroy;
begin
  inherited Destroy;
end; // TPLSmallPotions.Destroy

function TPLSmallPotions.Create2: TPLGameSprite;
begin
  Result:=TPLSmallPotions.Create(nil,PrinceOfPersia);
end; // TPLSmallPotions.Create2

{ TPLSword }
constructor TPLSword.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,0,LevelElements[78].Picture.Bitmap);
  end; // with
end; // TPLSword.Create

destructor TPLSword.Destroy;
begin
  inherited Destroy;
end; // TPLSword.Destroy

function TPLSword.Create2: TPLGameSprite;
begin
  Result:=TPLSword.Create(nil,PrinceOfPersia);
end; // TPLSword.Create2

{ TPLLevelDoorRight }
constructor TPLLevelDoorRight.Create(aImageItem: TPLImageListItem;aPrinceOfPersia: TPlPrinceOfPersia);
begin
  inherited Create(aImageItem, aPrinceOfPersia);
  with PrinceOfPersia do begin
    BitMap.Width:=TileWidth;
    BitMap.Height:=TileHeight;
    BitMap.Canvas.Brush.Color:=clBlack;
    BitMap.Canvas.FillRect(0,0,BitMap.Width,BitMap.Height);
    BitMap.Canvas.Draw(0,6,LevelElements[57].Picture.Bitmap); // frame lower right.bmp
    BitMap.Canvas.Draw(0,0,LevelElements[59].Picture.Bitmap); // frame upper right.bmp

{    BitMap.Canvas.Draw(8,12,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,16,LevelElements[53].Picture.Bitmap);  // door bottom.bmp
    BitMap.Canvas.Draw(8,20,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,24,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,28,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,32,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,36,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,40,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,44,LevelElements[53].Picture.Bitmap); // door bottom.bmp
    BitMap.Canvas.Draw(8,48,LevelElements[53].Picture.Bitmap);}

//    BitMap.Canvas.Draw(8,50,LevelElements[53].Picture.Bitmap);

    BitMap.Canvas.Draw(0,66,LevelElements[2].Picture.Bitmap);
  end;
end; // TPLLevelDoorRight.Create

destructor TPLLevelDoorRight.Destroy;
begin
  inherited Destroy;
end; // TPLLevelDoorRight.Destroy

function TPLLevelDoorRight.Create2: TPLGameSprite;
begin
  Result:=TPLLevelDoorRight.Create(nil,PrinceOfPersia);
end; // TPLLevelDoorRight.Create2

procedure TPLLevelDoorRight.Paint(Visible: Boolean);
begin
  inherited Paint(Visible);
end; // TPLLevelDoorRight.Paint

initialization

end.

